/*
  File name: CCytadelaMain.h
  Copyright: (C) 2005 - 2007 Tomasz Kazmierczak

  Creation date: 15.07.2005 20:24
  Last modification date: 23.04.2008

  This file is part of Cytadela

 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 3 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *

*/

#ifndef _CCYTADELAMAIN_H_
#define _CCYTADELAMAIN_H_

#include <stdint.h>
#include "CSDLClass.h"
#include "CCytadelaSave.h"
#include "CCytadelaGame.h"
#include "CInfoText.h"
#include "ILocalization.h"
#include "CCytadelaConfig.h"

class CCytadelaMain {
private:
	CSDLClass  *mSDL;
	const char *mLevels[26];
	const char *mSaveNames[21];
	const char *mCplxNames[7];
	const char *mCplxStatusName[4];
	GameState   mState;
	uint16_t    mCplxCounter;
	Status      mCplxStatus[7];
	Levels      mLevel;
	Levels      mBeginLevel[7];
	uint8_t     mActualComplex;
	ILocalization *mLocInterface;
	CInfoText   mTexts[TEXT_CLASSES_COUNT];
	char        mSysDirPath[FILENAME_MAX];

	void animateMapCursor(uint32_t dwCursorImg, uint32_t *pLastTime, uint32_t *pCursorFrame, uint32_t dwNum);
	bool saveScreen(uint32_t *pImgNums);
	bool configScreen(CCytadelaConfig *pConfig);
	bool startupScreen();
	bool errorScreen(const char *szErrorText);
	bool chooseComplex();
	bool endLevel();
	bool gameOver();
	void reset(CCytadelaConfig *pConfig);
	void setLevelTexts();

public:
	CCytadelaMain(const char *szSysDirPath);

	void runMain();
};

#endif
